/* Button styles ================ */

:root {
  --button-min-width: 100px;
  --button-height: 55px;
  --button-padding-horizontal: 30px;

  --button-border-radius: 30px;

  --button-font-size: var(--text-size-main);
  --button-font-weight: var(--text-font-weight-bold);

  --button-background-color: var(--color-yellow);
  --button-background-color-hover: color-mod(var(--color-yellow) whiteness(40%));
  --button-background-color-active: color-mod(var(--color-yellow) whiteness(20%));

  --button-border: 1px solid var(--button-background-color);
  --button-border-color-hover: var(--button-background-color-hover);
  --button-border-color-active: var(--button-background-color-active);

  --button-text-color: var(--color-primary);
  --button-text-color-hover: var(--color-primary);

  --button-box-shadow: 2px 10px 24px rgba(157, 152, 147, .74);

  /* Button white */
  --button-background-color-white: var(--color-white);
  --button-background-color-white-hover: color-mod(var(--color-white) lightness(95%));
  --button-background-color-white-active: color-mod(var(--color-white) lightness(90%));

  --button-border-color-white: var(--button-background-color-white);
  --button-border-color-white-hover: var(--button-background-color-white-hover);
  --button-border-color-white-active: var(--button-background-color-white-active);

  /* Button transparent */
  --button-background-color-transparent: transparent;
  --button-background-color-transparent-hover: var(--button-background-color);
  --button-background-color-transparent-active: var(--button-background-color-hover);

  --button-border-color-transparent: var(--button-background-color);
  --button-border-color-transparent-hover: var(--button-background-color-transparent-hover);
  --button-border-color-transparent-active: var(--button-background-color-transparent-active);

  /* Button medium */
  --button-height-medium: 34px;
  --button-font-size-medium: var(--text-size-main-small);

  --button-lg-padding: 80px;

  @media (--laptop-max) {
    --button-lg-padding: 50px;
  }

  @media (--laptop-small-max) {
    --button-height: 40px;
    --button-height-medium: 34px;
    --button-lg-padding: 30px;
  }
}

.button {
  z-index: var(--z-index-button);

  display: inline-flex;
  align-items: center;
  justify-content: center;

  min-width: var(--button-min-width);
  max-width: 100%;
  height: var(--button-height);
  padding-right: var(--button-padding-horizontal);
  padding-left: var(--button-padding-horizontal);

  border: var(--button-border);
  border-radius: var(--button-border-radius);
  overflow: hidden;

  color: var(--button-text-color);
  font-weight: var(--button-font-weight);
  font-size: var(--button-font-size);
  text-align: center;
  text-decoration: none;

  background-color: var(--button-background-color);
  box-shadow: var(--button-box-shadow);

  cursor: pointer;
  transition: background-color .3s ease;
  -webkit-appearance: inherit;
  user-select: none;
  touch-action: manipulation;

  &:hover {
    border-color: var(--button-border-color-hover);
    color: var(--button-text-color-hover);
    text-decoration: none;
    background-color: var(--button-background-color-hover);
  }

  &:focus {
    outline-width: 4px;
    outline-color: #5ac5f1;
  }

  &:active {
    border-color: var(--button-border-color-active);
    background-color: var(--button-background-color-active);
  }

  &.button--full-width {
    width: 100%;
  }

  &.button--text-uppercase {

    @media (--tablet-small-min) {
      text-transform: uppercase;
    }
  }

  &.button--text-white {
    color: var(--color-white);
  }
}

.button--white {
  border-color: var(--button-border-color-white);
  background-color: var(--button-background-color-white);

  &:hover {
    border-color: var(--button-border-color-white-hover);
    background-color: var(--button-background-color-white-hover);
  }

  &:active {
    border-color: var(--button-border-color-white-active);
    background-color: var(--button-background-color-white-active);
  }
}

.button--transparent {
  border-color: var(--button-border-color-transparent);
  background-color: var(--button-background-color-transparent);
  box-shadow: none;

  &:hover {
    border-color: var(--button-border-color-transparent-hover);
    background-color: var(--button-background-color-transparent-hover);
  }

  &:active {
    border-color: var(--button-border-color-transparent-active);
    background-color: var(--button-background-color-transparent-active);
  }
}

.button--medium {
  height: var(--button-height-medium);
  font-size: var(--button-font-size-medium);
}

.button-lg-padding {
  padding-right: var(--button-lg-padding);
  padding-left: var(--button-lg-padding);
}

.button__text {
  overflow: hidden;
  color: currentColor;
  white-space: nowrap;
  text-overflow: ellipsis;

  + .button__icon {
    margin-left: 7px;
  }
}

.button__icon {
  width: 8px;
  height: 13px;
}

/* disabled styles */
.button--disabled,
.button[disabled],
fieldset[disabled] .button {
  box-shadow: none;
  opacity: .32;
  cursor: not-allowed;
  pointer-events: none;
}

button[type = "button"] {
  cursor: pointer;
}
/* ================ end button styles */
